diff --git a/lib/hive/commands/web.rb b/lib/hive/commands/web.rb
index eb3cd40fc..32b80028f 100644
--- a/lib/hive/commands/web.rb
+++ b/lib/hive/commands/web.rb
@@ -1,4 +1,8 @@
+require "fileutils"
+require "json"
 require "hive/config"
+require "hive/invoked_binary"
+require "hive/web/auth_policy"
 require "hive/web/session_secret"
 
 module Hive
@@ -7,14 +11,84 @@ module Hive
     # (shipped in the Docker image at /app/web). hive itself stays a plain
     # CLI gem; the web tier is only supported where the Rails app and its
     # bundle exist: the hivebox container or a source checkout.
+    #
+    # Lifecycle subcommands:
+    #   (none | run)   Run the server in the FOREGROUND (execs bin/rails).
+    #   install [--force]  (Re)write the platform-native unit (systemd-user /
+    #                       launchd) and enable autostart. The web service is
+    #                       deliberately separate from `hive-daemon`.
+    #   start          Start the managed web service via the service manager.
+    #   stop           Stop the managed web service via the service manager.
+    #   status [--json] Show the managed web service state.
     class Web
-      def initialize(bind: nil, port: nil)
+      VALID_SUBCOMMANDS = %w[run start stop status install].freeze
+
+      def initialize(subcommand = nil, bind: nil, port: nil, json: false, force: false,
+                     allow_non_loopback: false, runner: nil,
+                     host_os: nil, home: nil, systemctl_available: nil)
+        @subcommand = (subcommand || "run").to_s
         @bind = bind
         @port = port
+        @json = json
+        @force = force
+        @allow_non_loopback = allow_non_loopback
+        @runner = runner || ->(argv) { system(*argv, out: File::NULL) }
+        @host_os = host_os
+        @home = home
+        @systemctl_available = systemctl_available
       end
 
       def call
-        cfg = Hive::Config.load_global_web
+        unless VALID_SUBCOMMANDS.include?(@subcommand)
+          raise Hive::InvalidTaskPath,
+                "hive web: unknown subcommand #{@subcommand.inspect} " \
+                "(expected: #{VALID_SUBCOMMANDS.join(', ')})"
+        end
+
+        case @subcommand
+        when "run"      then run_foreground
+        when "install"  then install_web
+        when "start"    then start_service
+        when "stop"     then stop_service
+        when "status"   then status_web
+        end
+      end
+
+      private
+
+      def cfg
+        @cfg ||= Hive::Config.load_global_web
+      end
+
+      # Loopback no-auth / non-loopback refusal predicate, shared with the
+      # Rails controller (ApplicationController#require_login) so the CLI
+      # can never green-light a bind the app will 403. Returns true when
+      # this bind MUST be refused.
+      #
+      # Semantics (fail-closed by default):
+      #   - loopback bind (127.0.0.1, ::1, localhost) ⇒ never refused —
+      #     with web.github.owner unset this is single-user local mode
+      #     (no auth); with an owner set the app keeps the owner gate.
+      #   - non-loopback bind (0.0.0.0, LAN IP) with an explicit
+      #     --allow-non-loopback/--unsafe flag ⇒ allowed with a loud
+      #     warning (operator takes responsibility for the boundary).
+      #   - non-loopback bind with no field AND no web.github.owner ⇒
+      #     refuse (fail-closed).
+      def refused_bind?(bind:)
+        return false if Hive::Web::AuthPolicy.loopback_bind?(bind)
+        return false if @allow_non_loopback
+
+        Hive::Web::AuthPolicy.owner_unset?(cfg)
+      end
+
+      def run_foreground
+        if @json
+          message = "hive web run has no JSON output (it runs a long-lived server). " \
+                    "Use 'hive status --json' for machine-readable task data."
+          warn message
+          exit Hive::ExitCodes::USAGE
+        end
+
         bind = @bind || cfg.fetch("bind")
         port = (@port || cfg.fetch("port")).to_i
         app_dir = rails_app_dir
@@ -25,7 +99,14 @@ module Hive
           exit 1
         end
 
-        warn_on_public_bind(bind, cfg)
+        if refused_bind?(bind: bind)
+          warn "hive web: refusing to bind #{bind} without web.github.owner set. " \
+               "Local single-user mode requires a loopback bind (default 127.0.0.1). " \
+               "To serve on a non-loopback interface you must either set web.github.owner " \
+               "in ~/.config/hive/config.yml (which re-enables the GitHub owner gate) or " \
+               "pass --allow-non-loopback to take responsibility for auth at the boundary."
+          exit 1
+        end
 
         env = {
           "RAILS_ENV" => ENV.fetch("RAILS_ENV", "production"),
@@ -42,6 +123,13 @@ module Hive
             File.join(Hive::Paths.state_home, "web-storage"),
           "BUNDLE_GEMFILE" => File.join(app_dir, "Gemfile")
         }
+        # Forward the CLI-resolved hive binary so the Rails-side daemon repair
+        # endpoint can re-exec `hive daemon repair`. Inside the Rails process
+        # `$PROGRAM_NAME` is `bin/rails`, so Hive::InvokedBinary.path returns
+        # nil there and only this env var can supply the binary (the systemd
+        # unit bakes the same value into Environment=HIVE_BIN=).
+        hive_bin = Hive::InvokedBinary.path
+        env["HIVE_BIN"] = hive_bin if hive_bin
         FileUtils.mkdir_p(env.fetch("HIVEBOX_STORAGE_DIR"))
 
         Dir.chdir(app_dir) do
@@ -62,7 +150,263 @@ module Hive
         end
       end
 
-      private
+      # Managed-service start: delegate to the service manager (systemd-user
+      # on Linux, launchd on macOS). This is the autostart/unit path; a raw
+      # `hive web run` is the manual foreground path.
+      def start_service
+        installer = build_installer
+        ok =
+          case installer.send(:platform)
+          when :macos then @runner.call([ "launchctl", "kickstart", "-k", "gui/#{Process.uid}/#{installer.launchd_label}" ])
+          when :linux then @runner.call(%w[systemctl --user start hive-web])
+          else false
+          end
+
+        if @json
+          puts JSON.generate(
+            "schema" => "hive-web-start",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-start"),
+            "ok" => ok,
+            "unit_path" => installer.target_path
+          )
+          return
+        end
+
+        unless ok
+          warn "hive web: failed to start the managed web service via the service manager; " \
+               "run `hive web run` in the foreground instead."
+          exit Hive::ExitCodes::SOFTWARE
+        end
+        puts "hive web: start requested (see `hive web status`)"
+      end
+
+      def stop_service
+        installer = build_installer
+        ok =
+          case installer.send(:platform)
+          when :macos
+            @runner.call([ "launchctl", "bootout", "gui/#{Process.uid}/#{installer.launchd_label}" ]) ||
+              @runner.call([ "launchctl", "unload", installer.target_path ])
+          when :linux
+            @runner.call(%w[systemctl --user stop hive-web])
+          end
+
+        if @json
+          puts JSON.generate(
+            "schema" => "hive-web-stop",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-stop"),
+            "ok" => !!ok,
+            "unit_path" => installer.target_path
+          )
+          return
+        end
+
+        unless ok
+          warn "hive web: managed web service is not supported on this platform; " \
+               "run `hive web run` in the foreground instead."
+          exit Hive::ExitCodes::SOFTWARE
+        end
+
+        puts "hive web: stop requested"
+      end
+
+      def status_web
+        installer = build_installer
+        state = begin
+          installer.service_state
+        rescue StandardError
+          { "service_installed" => nil, "service_enabled" => nil, "unit_path" => nil }
+        end
+        running =
+          case installer.send(:platform)
+          when :macos then @runner.call([ "launchctl", "list", installer.launchd_label ])
+          when :linux then @runner.call(%w[systemctl --user is-active hive-web])
+          else false
+          end
+
+        if @json
+          puts JSON.generate(
+            "schema" => "hive-web-status",
+            "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-status"),
+            "ok" => true,
+            "running" => running,
+            "service_installed" => state["service_installed"],
+            "service_enabled" => state["service_enabled"],
+            "unit_path" => state["unit_path"],
+            "current_version" => Hive::VERSION
+          )
+        else
+          puts "hive web: running: #{running ? 'yes' : 'no'}; " \
+               "installed: #{state["service_installed"] ? 'yes' : 'no'}; " \
+               "enabled: #{state["service_enabled"] ? 'yes' : 'no'} " \
+               "(unit: #{state["unit_path"]})"
+        end
+        raise Hive::Error, "web service not running" if !running && !@json
+      end
+
+      def install_web
+        installer = build_installer
+        begin
+          result = installer.install!(autostart: true, force: @force)
+        rescue Hive::Error
+          raise
+        rescue StandardError => e
+          install_emit_exception_envelope(installer, e) if @json
+          raise WebInstallFailed, "web service install failed: #{e.class}: #{e.message}"
+        end
+        unless @json
+          installer.messages.each { |line| warn "hive: #{line}" }
+          emit_install_success_summary(installer, result)
+        end
+        emit_install_outcome(installer, result)
+      end
+
+      def emit_install_success_summary(installer, outcome)
+        return if @json
+
+        case outcome.kind
+        when :written
+          puts "hive web: installed unit at #{installer.target_path}"
+        when :upgraded
+          msg = "hive web: upgraded unit at #{installer.target_path}"
+          msg += " (backup: #{outcome.backup_path})" if outcome.backup_path
+          puts msg
+        when :unchanged
+          puts "hive web: unit already up to date at #{installer.target_path}"
+        when :autostart_unavailable
+          puts "hive web: unit written at #{installer.target_path}; autostart not enabled on this host"
+        when :unsupported, :drifted, :failed
+          # :unsupported is messaged via installer.messages.
+          # :drifted / :failed are handled by emit_install_outcome.
+        end
+      end
+
+      def emit_install_outcome(installer, outcome)
+        if @json
+          if outcome.success?
+            puts JSON.generate(install_envelope(installer, outcome))
+          else
+            install_emit_error_envelope(installer, outcome: outcome.wire_outcome)
+          end
+        end
+
+        if outcome.drifted?
+          msg = "web unit at #{installer.target_path} differs from the current template. " \
+                "Re-run with `hive web install --force` to overwrite (a timestamped .bak " \
+                "will be saved)."
+          raise WebInstallDriftError, msg
+        elsif outcome.failed?
+          raise WebInstallFailed, "web service install reported a failure; see messages above"
+        end
+      end
+
+      def install_envelope(installer, outcome)
+        {
+          "schema" => "hive-web-install",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+          "ok" => true,
+          "outcome" => outcome.wire_outcome,
+          "platform" => installer.envelope_platform,
+          "target_path" => installer.target_path,
+          "backup_path" => outcome.backup_path,
+          "restarted" => outcome.restarted,
+          "messages" => installer.messages.dup
+        }
+      end
+
+      def install_emit_error_envelope(installer, outcome:)
+        error_class = outcome == "drifted" ? "WebInstallDriftError" : "WebInstallFailed"
+        exit_code = outcome == "drifted" ? Hive::ExitCodes::USAGE : Hive::ExitCodes::SOFTWARE
+        message =
+          if outcome == "drifted"
+            "web unit at #{installer.target_path} differs from the current template; retry with --force."
+          else
+            "web service install reported a failure; see messages"
+          end
+        puts JSON.generate(
+          "schema" => "hive-web-install",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+          "ok" => false,
+          "error_class" => error_class,
+          "error_kind" => outcome,
+          "exit_code" => exit_code,
+          "message" => message,
+          "outcome" => outcome,
+          "platform" => installer.envelope_platform,
+          "target_path" => installer.target_path,
+          "messages" => installer.messages.dup
+        )
+      end
+
+      def install_emit_exception_envelope(installer, error)
+        puts JSON.generate(
+          "schema" => "hive-web-install",
+          "schema_version" => Hive::Schemas::SCHEMA_VERSIONS.fetch("hive-web-install"),
+          "ok" => false,
+          "error_class" => "WebInstallFailed",
+          "error_kind" => "failed",
+          "exit_code" => Hive::ExitCodes::SOFTWARE,
+          "message" => "web service install failed: #{error.class}: #{error.message}",
+          "outcome" => "failed",
+          "platform" => safe_install_platform(installer),
+          "target_path" => safe_install_target_path(installer),
+          "messages" => safe_install_messages(installer)
+        )
+      end
+
+      def current_binary_path
+        Hive::InvokedBinary.path
+      end
+
+      # Build the service installer with injectable test seams (host_os /
+      # home / systemctl_available / runner) so unit tests are hermetic and
+      # never touch the real home or a live service manager.
+      def build_installer
+        require "hive/commands/web/service_installer"
+        Hive::Commands::Web::ServiceInstaller.new(
+          host_os: @host_os,
+          home: @home,
+          binary_path: current_binary_path,
+          runner: @runner,
+          systemctl_available: @systemctl_available
+        )
+      end
+
+      def safe_install_platform(installer)
+        installer.envelope_platform
+      rescue StandardError
+        "unsupported"
+      end
+
+      def safe_install_target_path(installer)
+        installer.target_path
+      rescue StandardError
+        nil
+      end
+
+      def safe_install_messages(installer)
+        installer.messages.dup
+      rescue StandardError
+        []
+      end
+
+      # Subclassed error classes so callers can rescue them specifically.
+      # Exit-code overrides mirror the daemon/bot install outcome split:
+      # drift is a recoverable USAGE error (64, re-run with --force), a
+      # service-manager failure is SOFTWARE (70). The JSON envelope already
+      # reported 64/70, but the raised error mapped to GENERIC (1) — the
+      # envelope lied and automation branching on the process exit code saw
+      # the wrong value.
+      class WebInstallFailed < Hive::Error
+        def exit_code
+          Hive::ExitCodes::SOFTWARE
+        end
+      end
+      class WebInstallDriftError < Hive::Error
+        def exit_code
+          Hive::ExitCodes::USAGE
+        end
+      end
 
       def rails_app_dir
         candidates = [
@@ -71,18 +415,6 @@ module Hive
         ].compact
         candidates.find { |dir| File.file?(File.join(dir, "config", "application.rb")) }
       end
-
-      # Rails' production host authorization is inactive by default — the box
-      # assumes a trusted reverse proxy validates Host, exactly like the
-      # pre-Rails posture. Binding a public interface without that proxy
-      # exposes the app to DNS-rebinding / Host-injection, so make it loud.
-      def warn_on_public_bind(bind, cfg)
-        return unless bind.to_s == "0.0.0.0"
-        return if cfg["origin"].to_s.start_with?("https://")
-
-        warn "hive web: WARNING binding 0.0.0.0 without an https origin — " \
-             "ensure a trusted reverse proxy validates the Host header."
-      end
     end
   end
 end
diff --git a/lib/hive/commands/web/service_installer.rb b/lib/hive/commands/web/service_installer.rb
new file mode 100644
index 000000000..023b0d4e3
--- /dev/null
+++ b/lib/hive/commands/web/service_installer.rb
@@ -0,0 +1,85 @@
+require "cgi"
+require "shellwords"
+require "hive/commands/service_installer/base"
+
+module Hive
+  module Commands
+    class Web
+      # Per-user autostart installer for the local web UI. Inherits the
+      # platform-agnostic mechanics (drift/backup, atomic write, shim-PATH
+      # detection, enable/load orchestration) from the shared base and
+      # supplies only the web service's identity and rendered unit/plist
+      # bodies.
+      #
+      # The web service is deliberately SEPARATE from `hive-daemon`
+      # (daemon + web are never merged into one unit) so each can be
+      # restarted independently. The unit runs `hive web run` in the
+      # foreground — the service manager is the supervisor (mirroring the
+      # container supervisor, which spawns `hive web --bind 0.0.0.0`
+      # directly).
+      #
+      # The web bind/port are read from the same ~/.config/hive/config.yml
+      # the CLI uses, so the unit needs no baked --bind/--port. The
+      # Hive::InvokedBinary.path guarantee (same binary/version as the CLI)
+      # comes from the shared base's `resolved_binary`.
+      class ServiceInstaller < Hive::Commands::ServiceInstaller::Base
+        def service_name
+          "hive-web"
+        end
+
+        def cli_label
+          "web"
+        end
+
+        def service_noun
+          "web service"
+        end
+
+        def unit_noun
+          "web unit"
+        end
+
+        def target_path
+          case platform
+          when :macos then File.join(@home, "Library/LaunchAgents/local.hive-web.plist")
+          when :linux then File.join(@home, ".config/systemd/user/hive-web.service")
+          end
+        end
+
+        # The web tier has no in-flight child drain like the daemon's
+        # stop-hook fix workers, so the daemon's up-to-900s restart warning
+        # does not apply. No override needed.
+
+        private
+
+        def render_systemd
+          template = File.read(File.expand_path("../../../../examples/systemd/hive-web.service", __dir__))
+          # systemd .service files are POSIX-shell-ish — escape the
+          # resolved binary path so whitespace, `%`, or other special
+          # characters don't produce a malformed unit.
+          escaped = Shellwords.escape(resolved_binary)
+          template
+            .sub(/^ExecStart=.*$/, "ExecStart=#{escaped} web run")
+            .sub(/^Environment=HIVE_BIN=.*$/, "Environment=HIVE_BIN=#{escaped}")
+            .sub(/^Environment=PATH=.*$/, build_path_line)
+        end
+
+        def render_launchd
+          template = File.read(File.expand_path("../../../../examples/launchd/hive-web.plist", __dir__))
+          binary = resolved_binary
+          # dirname BEFORE HTML-escaping so paths with `&`/`<`/`>` get
+          # the correct directory segmentation; then escape both for
+          # plist XML safety.
+          binary_dir = File.dirname(binary)
+          escaped_binary = CGI.escapeHTML(binary)
+          escaped_binary_dir = CGI.escapeHTML(binary_dir)
+          escaped_home = CGI.escapeHTML(@home)
+          template
+            .gsub(%r{<string>/Users/YOU/\.local/bin/hive</string>}, "<string>#{escaped_binary}</string>")
+            .gsub("/Users/YOU/Library/Logs", "#{escaped_home}/Library/Logs")
+            .gsub("/Users/YOU/.local/bin", escaped_binary_dir)
+        end
+      end
+    end
+  end
+end
diff --git a/lib/hive/daemon/drift.rb b/lib/hive/daemon/drift.rb
new file mode 100644
index 000000000..f31841fd9
--- /dev/null
+++ b/lib/hive/daemon/drift.rb
@@ -0,0 +1,159 @@
+require "hive/invoked_binary"
+require "open3"
+require "shellwords"
+
+module Hive
+  module Daemon
+    # Binary/version drift detection for the running daemon vs. the CLI that
+    # invoked this status/repair call. Ensures the daemon runs with the SAME
+    # hive binary/version as the CLI so newly created tasks are picked up
+    # from either the TUI or the web.
+    #
+    # Drift is REPORTED, never silently auto-fixed: `hive setup` and the web
+    # repair button invoke the explicit reinstall/restart path (the `daemon
+    # repair` re-run of `install --force`). Platform-fragility is handled by
+    # reporting `verified: false` (and drifting as "unverified") rather than
+    # guessing when the live process binary cannot be resolved.
+    #
+    # Burning the PID-ownership discipline from Hive::PidFile: callers must
+    # pass a PID they have already proved belongs to the daemon (from a live,
+    # owned pidfile). This helper only resolves the binary for that PID.
+    class Drift
+      def initialize(pid:, runner: nil)
+        @pid = pid
+        @runner = runner || default_runner
+      end
+
+      # Returns a Hash describing the running daemon's binary/version versus
+      # the current CLI. Fields:
+      #   binary           absolute path of the running daemon's binary (nil if unresolvable)
+      #   version          the daemon binary's reported hive version (nil if unresolvable)
+      #   current_binary   Hive::InvokedBinary.path (the CLI wrapper)
+      #   current_version  Hive::VERSION
+      #   verified         true only when we could resolve the live binary
+      #   drifted          true when verified and binary/version differ from current
+      #   status           "ok" | "drifted" | "unverified"
+      def resolve
+        binary = resolve_binary
+        unless binary
+          return {
+            "binary" => nil, "version" => nil,
+            "current_binary" => Hive::InvokedBinary.path,
+            "current_version" => Hive::VERSION,
+            "verified" => false, "drifted" => nil, "status" => "unverified"
+          }
+        end
+
+        version = fetch_version(binary)
+        current_binary = Hive::InvokedBinary.path
+        # The documented `ln -s ~/Dev/hive/bin/hive ~/.local/bin/hive` install
+        # is a symlink. `resolve_binary` returns the hive WRAPPER script the
+        # daemon was launched with (parsed from the live command line), not
+        # the Ruby interpreter behind its shebang. Compare realpaths on BOTH
+        # sides so a path-only symlink difference never false-positives as
+        # drift. If the CLI wrapper cannot be resolved (weird PATH), fall back
+        # to comparing versions only so drift is still detectable.
+        drifted =
+          if current_binary
+            normalize_path(binary) != normalize_path(current_binary) ||
+              (version && version != Hive::VERSION)
+          else
+            version && version != Hive::VERSION
+          end
+        {
+          "binary" => binary,
+          "version" => version,
+          "current_binary" => current_binary,
+          "current_version" => Hive::VERSION,
+          "verified" => true,
+          "drifted" => drifted,
+          "status" => drifted ? "drifted" : "ok"
+        }
+      end
+
+      private
+
+      def default_runner
+        lambda do |argv|
+          out, _err, status = Open3.capture3(*argv)
+          { success: status.success?, out: out }
+        end
+      end
+
+      # Resolve symlinks for comparison; fall back to the raw path when the
+      # target can't be resolved (missing on disk, dangling link, perms).
+      def normalize_path(path)
+        return nil if path.nil?
+
+        File.realpath(path)
+      rescue StandardError
+        path
+      end
+
+      # Resolve the live process's hive wrapper script (NOT the Ruby
+      # interpreter). `hive daemon start` is a `#!/usr/bin/env ruby` script,
+      # so /proc/<pid>/exe resolves all the way through the shebang to the
+      # interpreter (`ruby`) — comparing that against the CLI wrapper would
+      # flag every healthy daemon as drifted. Walk the live command line
+      # instead: on Linux the process is `ruby <hive-script> daemon start`,
+      # so the first arg whose basename is a valid wrapper name (`hive`/`hv`)
+      # is the script. Returns nil when neither source works (no /proc,
+      # stripped ps) — the caller reports "unverified" rather than guessing.
+      def resolve_binary
+        args = process_args
+        return nil unless args
+
+        args.each do |arg|
+          next if arg.nil? || arg.empty?
+
+          name = File.basename(arg)
+          next unless Hive::InvokedBinary::VALID_NAMES.include?(name)
+
+          # A relative wrapper path is expanded against the CLI's cwd; a bare
+          # name is resolved via PATH (mirrors InvokedBinary.path).
+          path =
+            if arg.include?(File::SEPARATOR)
+              File.expand_path(arg)
+            else
+              Hive::InvokedBinary.which(name)
+            end
+          return File.realpath(path) if path && File.exist?(path)
+        end
+        nil
+      rescue StandardError
+        nil
+      end
+
+      # NUL-separated argv from /proc/<pid>/cmdline on Linux; on macOS / other
+      # hosts fall back to `ps -o command=` (the full command line, which keeps
+      # the script argument that `ps -o comm=` strips away).
+      def process_args
+        path = "/proc/#{@pid}/cmdline"
+        if File.exist?(path)
+          args = File.binread(path).split("\0")
+          return args unless args.empty?
+        end
+
+        return nil unless @pid.is_a?(Integer) && @pid > 0
+
+        result = @runner.call([ "ps", "-o", "command=", "-p", @pid.to_s ])
+        line = result[:out].to_s.strip
+        return nil if line.empty?
+
+        Shellwords.split(line)
+      rescue StandardError
+        nil
+      end
+
+      def fetch_version(binary)
+        probe = @runner.call([ binary, "version" ])
+        return nil unless probe[:success]
+
+        m = probe[:out].to_s.match(/(\d+\.\d+\.\d+)/)
+        m && m[1]
+      rescue StandardError
+        nil
+      end
+    end
+  end
+end
diff --git a/lib/hive/web/auth_policy.rb b/lib/hive/web/auth_policy.rb
new file mode 100644
index 000000000..56753db13
--- /dev/null
+++ b/lib/hive/web/auth_policy.rb
@@ -0,0 +1,55 @@
+module Hive
+  module Web
+    # Shared loopback/no-auth predicate for local (non-Docker) single-user
+    # mode. The CLI bind check (`Hive::Commands::Web#refused_bind?`) and the
+    # Rails owner gate (`ApplicationController#require_login`) BOTH consult
+    # this one module so the CLI can never green-light a bind the app will
+    # 403, and the app can never silently allow a non-loopback request.
+    #
+    # Semantics (fail-closed by default):
+    #   - loopback bind/host (127.0.0.1, ::1, localhost) with web.github.owner
+    #     unset ⇒ single-user local mode: no auth required.
+    #   - loopback bind/host with web.github.owner set ⇒ the owner gate is
+    #     kept (owner claim/owner flow still applies).
+    #   - any non-loopback bind/host ⇒ the owner gate applies; a non-loopback
+    #     CLI bind without owner and without --allow-non-loopback is REFUSED.
+    module AuthPolicy
+      # Binds that are, for auth purposes, loopback. `0.0.0.0` is NOT here —
+      # it fans out to all interfaces and must go through the owner gate /
+      # explicit unsafe flag.
+      LOOPBACK_BINDS = %w[127.0.0.1 ::1 localhost].freeze
+
+      module_function
+
+      def loopback_bind?(bind)
+        LOOPBACK_BINDS.include?(bind.to_s)
+      end
+
+      # Rails `request.host` is host-only (no port). Normalise defensively for
+      # anything that passes an origin string with a port.
+      def loopback_host?(host)
+        host = host.to_s.delete_prefix("[").delete_suffix("]")
+        %w[127.0.0.1 ::1 localhost].include?(host)
+      end
+
+      def owner_unset?(config)
+        config.fetch("github", {}).fetch("owner", nil).to_s.strip.empty?
+      end
+
+      # Single-user local mode applies when the surface is loopback AND no
+      # owner is claimed. Used by the CLI to decide whether a loopback bind
+      # may run with no auth (and to refuse a non-loopback bind otherwise).
+      def single_user_local?(bind:, config:)
+        loopback_bind?(bind) && owner_unset?(config)
+      end
+
+      # Controller-side equivalent: True when a LOOPBACK REQUEST may bypass
+      # the GitHub owner gate because no owner is claimed. The CLI bind check
+      # decides whether to run at all; this decides whether an in-flight
+      # request needs a login.
+      def allows_unauthenticated?(host:, config:)
+        loopback_host?(host) && owner_unset?(config)
+      end
+    end
+  end
+end
